#Overwrite py2exe version to include Author in file version information
import py2exe.resources.VersionInfo
OldVersionInfo=py2exe.resources.VersionInfo.Version
class OverwriteVersionInfo(OldVersionInfo):
    def __init__(self, version, **NameParameters):
        OldVersionInfo.__init__(self, version, **NameParameters)
        self.strings.insert(0, ("Author", "Dakusan"))
py2exe.resources.VersionInfo.Version=OverwriteVersionInfo

#Prepare for distributing
from distutils.core import setup
import py2exe

#Version/Resource information
class PictureViewerTarget:
    def __init__(self, **kw):
        #Version information
        self.__dict__.update(kw)
        self.version="1, 0, 1, 0"
        self.product_version="1, 0, 1, 0"
        self.author="Dakusan"
        self.comments="http://www.castledragmire.com/Projects/Picture_Viewer"
        self.company_name = "Hyrulean Productions"
        self.description = "Cycles through a compiled list of image files for viewing at set intervals"
        self.copyright = "(Dakusan) Copyright \xa9 2010"
        self.dest_base = "PictureViewer" #Output Filename
        self.name = "Picture Viewer"
        #Import file information
        self.script = "PictureViewer.py"
        self.icon_resources = [(10, "HyruleanProductions.ico")] #This resource ID is used in the source code

#Compilation information
setup(
    windows=[PictureViewerTarget()], #Resource information
    data_files=[("", [ #Put data files in top level directory
        "PictureViewer.cfg", "Readme.txt", "LICENSE.txt", #Readme, Configuration, and License files
        r"WinStuff\Microsoft.VC90.CRT.manifest", r"WinStuff\msvcr90.dll" #Required manifest and dlls for Python v2.6
    ])],
    options={ "py2exe": {
        "excludes": [ #Files to exclude
            "pyreadline", "locale", "doctest", "pdb", "unittest", "difflib", "inspect", "optparse", "pickle", "calendar", #Unused base python modules
            "PIL.GimpGradientFile", "PIL.GimpPaletteFile", "PIL.ImageChops", "_imaging"], #PIL modules (_imaging is included in the base directory AND PIL directory, and only needs to be included in one)
        "includes": ["encodings.utf_16", "encodings.utf_8"], #utf-16 and utf-8 are the only encoding that needs to be added
        "compressed": True, #Compress library.zip
        "ascii": True, #Only include needed encodings
        "dll_excludes": ["unicodedata", "w9xpopen.exe"], #Unused dlls
        "bundle_files": 2, #Bundle all files into library.zip
        "optimize": 2 #Optimize byte codes
    } }
)